//--------------------------------------------------------------------
// tradingexpert.mq4 
//         MQL4.
//--------------------------------------------------------------------
#property copyright "Copyright  Book, 2007"
#property link      "http://AutoGraf.dp.ua"
//--------------------------------------------------------------- 1 --
                                   //    15
extern double StopLoss   =400;     // SL   
extern double TakeProfit =500;      //    
extern int    Period_MA_1=11;      //   1
extern int    Period_MA_2=31;      //   2
extern double Rastvor    =28.0;    //    
extern double Lots       =0.1;     //   . 
extern double Prots      =0.07;    //   


bool Work=true;                    //   .
string Symb;                       //  . 

static datetime New_Time;  
bool New_Bar; 
bool wayUP, wayDOWN;

extern string block_02 = "    ";

extern bool   AllPositions   = False; 		//   
extern bool   ProfitTrailing = True;  		//   
extern int    TrailingStop   = 100;    		//   
extern int    TrailingStep   = 50;     		//  
extern bool   UseSound       = True;  		//   
string NameFileSound  = "expert.wav";  		//   

extern int KPeriod=5;
extern int DPeriod=3;
extern int Slowing=3;
extern int MA_Method=0; // SMA 0, EMA 1, SMMA 2, LWMA 3

double cci1, cci2;
extern int kCCI = 14;  
double val1[];
double val2[];
int shift,counted_bars;
extern int CountBars=350;
int i;
double fastMAnow, slowMAnow, fastMAprevious, slowMAprevious;

extern int PriceField=0; // Low/High 0, Close/Close 1


extern int OverBoughtLevel  =80;
extern int OverSoldLevel    =20;
extern bool show_KD_cross=false;
extern bool show_K_OBOScross=true;
extern bool show_D_OBOScross=false;

int flagval1=0;
int flagval2=0;
      
//--------------------------------------------------------------- 2 --
int start()
  {
   int
   Total,                           //     
   Tip=-1,                          //  .  (B=0,S=1)
   Ticket;                          //  
   double
   MA_1_t,                          // . _1 
   MA_2_t,                          // . _2  
   MA_3_t,                          // . _3  
   MA_4_t,                          // . _4        
   Lot,                             // .   .
   Lts,                             // .   .
   Min_Lot,                         //   
   Step,                            //    
   Free,                            //   
   One_Lot,                         //   
   Price,                           //   
   SL,                              // SL   
   TP;                              // TP  
   bool
   Ans  =false,                     //    
   Cls_B=false,                     //     Buy
   Cls_S=false,                     //     Sell
   Opn_B=false,                     //     Buy
   Opn_S=false;                     //     Sell
//--------------------------------------------------------------- 3 --

   if (CountBars>=Bars) CountBars=Bars;
   SetIndexDrawBegin(0,Bars-CountBars);
   SetIndexDrawBegin(1,Bars-CountBars);
   int i,shift,counted_bars=IndicatorCounted();


   //---- check for possible errors
   if(counted_bars<0) return(-1);

   //---- initial zero
   if(counted_bars<1)
     {
      for(i=1;i<=CountBars;i++) val1[CountBars-i]=0.0;
      for(i=1;i<=CountBars;i++) val2[CountBars-i]=0.0;
     }
     
     
   // .
   if(Bars < Period_MA_2)                       //  
     {
      Alert("   .   .");
      return;                                   //   start()
     }
   if(Work==false)                              //  
     {
      Alert(" .   .");
      return;                                   //   start()
     }
//--------------------------------------------------------------- 4 --
   //  
   Symb=Symbol();                               //  ..
   Total=0;                                     //  
   for(i=1; i<=OrdersTotal(); i++)          //   
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) //   
        {                                       //  :
         if (OrderSymbol()!=Symb)continue;      //   . 
         /*
         if (OrderType()>1)                     //  
           {
            Alert("  . ");  //  .
            return;                                 //   start()
           }  
           */
           //       
		if (OrderType() == OP_BUY || OrderType() == OP_SELL) BBU();
         Total++;                               //  . 
         /* if (Total>1)                           //    
           {
            Alert("  .   .");
            return;                             //   start()
           }
         */  
         Ticket=OrderTicket();                  //  . .
         Tip   =OrderType();                    //   .
         Price =OrderOpenPrice();               //  . .
         SL    =OrderStopLoss();                // SL  .
         TP    =OrderTakeProfit();              // TP  .
         Lot   =OrderLots();                    //  
        }
     }
//--------------------------------------------------------------- 5 --
   if(New_Time!=Time[0])
     {
      New_Time=Time[0]; 
      New_Bar=true;
      } 
      else { New_Bar=false;
      }
//---------------------------------------------------------------- 5.1 
   cci1 = iCCI(NULL, 0, kCCI, PRICE_TYPICAL, 1);

   if (New_Bar==true && cci1>100 && flagval2==1)                // && MA_3_t==0   && wayDOWN==true
     {                                            
         Opn_B=true; New_Bar=false; Cls_S=true;                                  
         flagval1=1;
         flagval2=0;
     }
     
   if (New_Bar==true && cci1<-100 && flagval1==1)                 // && MA_4_t==0  && wayUP==true
     {                                                   
         Opn_S=true; New_Bar=false; Cls_B=true;
         flagval2=1;
         flagval1=0;
     }
//--------------------------------------------------------------- 6 --
   //  
   while(true)                                  //   .
     {
      if (Tip==0 && Cls_B==true)                //   Buy..
        {                                       //   
         Alert("  Buy ",Ticket,".  ..");
         RefreshRates();                        //  
         Ans=OrderClose(Ticket,Lot,Bid,2);      //  Buy
         if (Ans==true)                         //  :)
           {
            Alert ("  Buy ",Ticket);
            break;                              //    
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }

      if (Tip==1 && Cls_S==true)                //   Sell..
        {                                       //    
         Alert("  Sell ",Ticket,".  ..");
         RefreshRates();                        //  
         Ans=OrderClose(Ticket,Lot,Ask,2);      //  Sell
         if (Ans==true)                         //  :)
           {
            Alert ("  Sell ",Ticket);
            break;                              //    
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }
      break;                                    //   while
     }
//--------------------------------------------------------------- 7 --
   //  
   RefreshRates();                              //  
   Min_Lot=MarketInfo(Symb,MODE_MINLOT);        // . .  
   Free   =AccountFreeMargin();                 //  
   One_Lot=MarketInfo(Symb,MODE_MARGINREQUIRED);//  1 
   Step   =MarketInfo(Symb,MODE_LOTSTEP);       //   

   if (Lots > 0)                                //   , 
      Lts =Lots;                                //     
   else                                         // %  
      Lts=MathFloor(Free*Prots/One_Lot/Step)*Step;//  

   if(Lts < Min_Lot) Lts=Min_Lot;               //   
   if (Lts*One_Lot > Free)                      //   .
     {
      Alert("     ", Lts," ");
      return;                                   //   start()
     }
//--------------------------------------------------------------- 8 --
   //  
   while(true)                                  //   .
     {
      if (Opn_B==true)              //  .  + // Total==0 && 
        {                                       //  . Buy
         RefreshRates();                        //  
         SL=Bid - New_Stop(StopLoss)*Point;     //  SL .
         TP=Bid + New_Stop(TakeProfit)*Point;   //  TP .
         Alert("  Buy.  ..");
         Ticket=OrderSend(Symb,OP_BUY,Lts,Ask,2,SL,TP);// Buy
         if (Ticket > 0)                        //  :)
           {
            Alert ("  Buy ",Ticket);
            return;                             //   start()
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }
      if (Opn_S==true)                          //  .  + //Total==0 && 
        {                                       //  . Sell
         RefreshRates();                        //  
         SL=Ask + New_Stop(StopLoss)*Point;     //  SL .
         TP=Ask - New_Stop(TakeProfit)*Point;   //  TP .
         Alert("  Sell.  ..");
         Ticket=OrderSend(Symb,OP_SELL,Lts,Bid,2,SL,TP);// Sel
         if (Ticket > 0)                        //  :)
           {
            Alert ("  Sell ",Ticket);
            return;                             //   start()
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }
      break;                                    //   while
     }
//--------------------------------------------------------------- 9 --
   return;                                      //   start()
  }
//-------------------------------------------------------------- 10 --
int Fun_Error(int Error)                        // -  
  {
   switch(Error)
     {                                          //              
      case  4: Alert("  .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 135:Alert(" .   ..");
         RefreshRates();                        //  
         return(1);                             //   
      case 136:Alert(" .   ..");
         while(RefreshRates()==false)           //   
            Sleep(1);                           //   
         return(1);                             //   
      case 137:Alert(" .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 146:Alert("  .  ..");
         Sleep(500);                            //  
         return(1);                             //   
         //  
      case  2: Alert(" .");
         return(0);                             //   
      case  5: Alert("  .");
         Work=false;                            //   
         return(0);                             //   
      case 64: Alert(" .");
         Work=false;                            //   
         return(0);                             //   
      case 133:Alert(" .");
         return(0);                             //   
      case 134:Alert("    .");
         return(0);                             //   
      default: Alert("  ",Error); //     
         return(0);                             //   
     }
  }
//-------------------------------------------------------------- 11 --
int New_Stop(int Parametr)                      //  -.
  {
   int Min_Dist=MarketInfo(Symb,MODE_STOPLEVEL);// . 
   if (Parametr<Min_Dist)                       //   .
     {
      Parametr=Min_Dist;                        //  .
      Alert("  -.");
     }
   return(Parametr);                            //  
  }
//-------------------------------------------------------------- 12 --


//-------------------------------------------------------------- 13 --
// ========================================================
// ============     ===============
// ========================================================
void BBU() {
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (AllPositions || OrderSymbol()==Symbol()) {
        TrailingPositions();
      }
    }
  }
}
void TrailingPositions() {
  double pBid, pAsk, pp;

  pp = MarketInfo(OrderSymbol(), MODE_POINT);
  if (OrderType()==OP_BUY) {
    pBid = MarketInfo(OrderSymbol(), MODE_BID);
    if (!ProfitTrailing || (pBid-OrderOpenPrice())>TrailingStop*pp) {
      if (OrderStopLoss()<pBid-(TrailingStop+TrailingStep-1)*pp) {
        ModifyStopLoss(pBid-TrailingStop*pp);
        return;
      }
    }
  }
  if (OrderType()==OP_SELL) {
    pAsk = MarketInfo(OrderSymbol(), MODE_ASK);
    if (!ProfitTrailing || OrderOpenPrice()-pAsk>TrailingStop*pp) {
      if (OrderStopLoss()>pAsk+(TrailingStop+TrailingStep-1)*pp || OrderStopLoss()==0) {
        ModifyStopLoss(pAsk+TrailingStop*pp);
        return;
      }
    }
  }
}
void ModifyStopLoss(double ldStopLoss) {
  bool fm;

  fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE);
  if (fm && UseSound) PlaySound(NameFileSound);
}
//-------------------------------------------------------------- 13 --